Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 0e673013 2019-01-02 stsp # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 0e673013 2019-01-02 stsp . ./common.sh
18 0e673013 2019-01-02 stsp
19 f6cae3ed 2020-09-13 naddy test_checkout_basic() {
20 0e673013 2019-01-02 stsp local testroot=`test_init checkout_basic`
21 0e673013 2019-01-02 stsp
22 0e673013 2019-01-02 stsp echo "A $testroot/wt/alpha" > $testroot/stdout.expected
23 0e673013 2019-01-02 stsp echo "A $testroot/wt/beta" >> $testroot/stdout.expected
24 0e673013 2019-01-02 stsp echo "A $testroot/wt/epsilon/zeta" >> $testroot/stdout.expected
25 0e673013 2019-01-02 stsp echo "A $testroot/wt/gamma/delta" >> $testroot/stdout.expected
26 0e673013 2019-01-02 stsp echo "Now shut up and hack" >> $testroot/stdout.expected
27 0e673013 2019-01-02 stsp
28 0e673013 2019-01-02 stsp got checkout $testroot/repo $testroot/wt > $testroot/stdout
29 e60e7f5b 2019-02-10 stsp ret="$?"
30 e60e7f5b 2019-02-10 stsp if [ "$ret" != "0" ]; then
31 e60e7f5b 2019-02-10 stsp test_done "$testroot" "$ret"
32 0e673013 2019-01-02 stsp return 1
33 0e673013 2019-01-02 stsp fi
34 0e673013 2019-01-02 stsp
35 8d301dd9 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
36 e60e7f5b 2019-02-10 stsp ret="$?"
37 e60e7f5b 2019-02-10 stsp if [ "$ret" != "0" ]; then
38 0e673013 2019-01-02 stsp diff -u $testroot/stdout.expected $testroot/stdout
39 e60e7f5b 2019-02-10 stsp test_done "$testroot" "$ret"
40 0e673013 2019-01-02 stsp return 1
41 0e673013 2019-01-02 stsp fi
42 0e673013 2019-01-02 stsp
43 0e673013 2019-01-02 stsp echo "alpha" > $testroot/content.expected
44 0e673013 2019-01-02 stsp echo "beta" >> $testroot/content.expected
45 0e673013 2019-01-02 stsp echo "zeta" >> $testroot/content.expected
46 0e673013 2019-01-02 stsp echo "delta" >> $testroot/content.expected
47 0e673013 2019-01-02 stsp cat $testroot/wt/alpha $testroot/wt/beta $testroot/wt/epsilon/zeta \
48 0e673013 2019-01-02 stsp $testroot/wt/gamma/delta > $testroot/content
49 0e673013 2019-01-02 stsp
50 8d301dd9 2019-05-14 stsp cmp -s $testroot/content.expected $testroot/content
51 693719bc 2019-01-03 stsp ret="$?"
52 693719bc 2019-01-03 stsp if [ "$ret" != "0" ]; then
53 0e673013 2019-01-02 stsp diff -u $testroot/content.expected $testroot/content
54 0e673013 2019-01-02 stsp fi
55 693719bc 2019-01-03 stsp test_done "$testroot" "$ret"
56 0e673013 2019-01-02 stsp }
57 0e673013 2019-01-02 stsp
58 f6cae3ed 2020-09-13 naddy test_checkout_dir_exists() {
59 80c1b583 2019-08-07 stsp local testroot=`test_init checkout_dir_exists`
60 80c1b583 2019-08-07 stsp
61 80c1b583 2019-08-07 stsp echo "A $testroot/wt/alpha" > $testroot/stdout.expected
62 80c1b583 2019-08-07 stsp echo "A $testroot/wt/beta" >> $testroot/stdout.expected
63 80c1b583 2019-08-07 stsp echo "A $testroot/wt/epsilon/zeta" >> $testroot/stdout.expected
64 80c1b583 2019-08-07 stsp echo "A $testroot/wt/gamma/delta" >> $testroot/stdout.expected
65 80c1b583 2019-08-07 stsp echo "Now shut up and hack" >> $testroot/stdout.expected
66 80c1b583 2019-08-07 stsp
67 80c1b583 2019-08-07 stsp mkdir $testroot/wt
68 80c1b583 2019-08-07 stsp
69 80c1b583 2019-08-07 stsp got checkout $testroot/repo $testroot/wt > $testroot/stdout
70 80c1b583 2019-08-07 stsp ret="$?"
71 80c1b583 2019-08-07 stsp if [ "$ret" != "0" ]; then
72 80c1b583 2019-08-07 stsp test_done "$testroot" "$ret"
73 80c1b583 2019-08-07 stsp return 1
74 80c1b583 2019-08-07 stsp fi
75 80c1b583 2019-08-07 stsp
76 80c1b583 2019-08-07 stsp cmp -s $testroot/stdout.expected $testroot/stdout
77 80c1b583 2019-08-07 stsp ret="$?"
78 80c1b583 2019-08-07 stsp if [ "$ret" != "0" ]; then
79 80c1b583 2019-08-07 stsp diff -u $testroot/stdout.expected $testroot/stdout
80 80c1b583 2019-08-07 stsp test_done "$testroot" "$ret"
81 80c1b583 2019-08-07 stsp return 1
82 80c1b583 2019-08-07 stsp fi
83 80c1b583 2019-08-07 stsp
84 80c1b583 2019-08-07 stsp echo "alpha" > $testroot/content.expected
85 80c1b583 2019-08-07 stsp echo "beta" >> $testroot/content.expected
86 80c1b583 2019-08-07 stsp echo "zeta" >> $testroot/content.expected
87 80c1b583 2019-08-07 stsp echo "delta" >> $testroot/content.expected
88 80c1b583 2019-08-07 stsp cat $testroot/wt/alpha $testroot/wt/beta $testroot/wt/epsilon/zeta \
89 80c1b583 2019-08-07 stsp $testroot/wt/gamma/delta > $testroot/content
90 80c1b583 2019-08-07 stsp
91 80c1b583 2019-08-07 stsp cmp -s $testroot/content.expected $testroot/content
92 80c1b583 2019-08-07 stsp ret="$?"
93 80c1b583 2019-08-07 stsp if [ "$ret" != "0" ]; then
94 80c1b583 2019-08-07 stsp diff -u $testroot/content.expected $testroot/content
95 80c1b583 2019-08-07 stsp fi
96 80c1b583 2019-08-07 stsp test_done "$testroot" "$ret"
97 80c1b583 2019-08-07 stsp }
98 80c1b583 2019-08-07 stsp
99 f6cae3ed 2020-09-13 naddy test_checkout_dir_not_empty() {
100 80c1b583 2019-08-07 stsp local testroot=`test_init checkout_dir_not_empty`
101 80c1b583 2019-08-07 stsp
102 80c1b583 2019-08-07 stsp echo "A $testroot/wt/alpha" > $testroot/stdout.expected
103 80c1b583 2019-08-07 stsp echo "A $testroot/wt/beta" >> $testroot/stdout.expected
104 80c1b583 2019-08-07 stsp echo "A $testroot/wt/epsilon/zeta" >> $testroot/stdout.expected
105 80c1b583 2019-08-07 stsp echo "A $testroot/wt/gamma/delta" >> $testroot/stdout.expected
106 80c1b583 2019-08-07 stsp echo "Now shut up and hack" >> $testroot/stdout.expected
107 80c1b583 2019-08-07 stsp
108 80c1b583 2019-08-07 stsp mkdir $testroot/wt
109 80c1b583 2019-08-07 stsp touch $testroot/wt/foo
110 80c1b583 2019-08-07 stsp
111 80c1b583 2019-08-07 stsp got checkout $testroot/repo $testroot/wt > $testroot/stdout \
112 80c1b583 2019-08-07 stsp 2> $testroot/stderr
113 80c1b583 2019-08-07 stsp ret="$?"
114 80c1b583 2019-08-07 stsp if [ "$ret" == "0" ]; then
115 80c1b583 2019-08-07 stsp echo "checkout succeeded unexpectedly" >&2
116 80c1b583 2019-08-07 stsp test_done "$testroot" "1"
117 80c1b583 2019-08-07 stsp return 1
118 80c1b583 2019-08-07 stsp fi
119 80c1b583 2019-08-07 stsp
120 80c1b583 2019-08-07 stsp echo "got: $testroot/wt: directory exists and is not empty" \
121 80c1b583 2019-08-07 stsp > $testroot/stderr.expected
122 80c1b583 2019-08-07 stsp cmp -s $testroot/stderr.expected $testroot/stderr
123 80c1b583 2019-08-07 stsp ret="$?"
124 80c1b583 2019-08-07 stsp if [ "$ret" != "0" ]; then
125 80c1b583 2019-08-07 stsp diff -u $testroot/stderr.expected $testroot/stderr
126 80c1b583 2019-08-07 stsp test_done "$testroot" "$ret"
127 80c1b583 2019-08-07 stsp return 1
128 80c1b583 2019-08-07 stsp fi
129 80c1b583 2019-08-07 stsp
130 80c1b583 2019-08-07 stsp echo -n > $testroot/stdout.expected
131 80c1b583 2019-08-07 stsp cmp -s $testroot/stdout.expected $testroot/stdout
132 80c1b583 2019-08-07 stsp ret="$?"
133 80c1b583 2019-08-07 stsp if [ "$ret" != "0" ]; then
134 80c1b583 2019-08-07 stsp diff -u $testroot/stdout.expected $testroot/stdout
135 80c1b583 2019-08-07 stsp fi
136 80c1b583 2019-08-07 stsp test_done "$testroot" "$ret"
137 80c1b583 2019-08-07 stsp
138 80c1b583 2019-08-07 stsp }
139 80c1b583 2019-08-07 stsp
140 f6cae3ed 2020-09-13 naddy test_checkout_sets_xbit() {
141 68ed9ba5 2019-02-10 stsp local testroot=`test_init checkout_sets_xbit 1`
142 68ed9ba5 2019-02-10 stsp
143 68ed9ba5 2019-02-10 stsp touch $testroot/repo/xfile
144 68ed9ba5 2019-02-10 stsp chmod +x $testroot/repo/xfile
145 68ed9ba5 2019-02-10 stsp (cd $testroot/repo && git add .)
146 68ed9ba5 2019-02-10 stsp git_commit $testroot/repo -m "adding executable file"
147 68ed9ba5 2019-02-10 stsp
148 68ed9ba5 2019-02-10 stsp echo "A $testroot/wt/xfile" > $testroot/stdout.expected
149 68ed9ba5 2019-02-10 stsp echo "Now shut up and hack" >> $testroot/stdout.expected
150 68ed9ba5 2019-02-10 stsp
151 68ed9ba5 2019-02-10 stsp got checkout $testroot/repo $testroot/wt > $testroot/stdout
152 68ed9ba5 2019-02-10 stsp ret="$?"
153 68ed9ba5 2019-02-10 stsp if [ "$ret" != "0" ]; then
154 68ed9ba5 2019-02-10 stsp test_done "$testroot" "$ret"
155 68ed9ba5 2019-02-10 stsp return 1
156 68ed9ba5 2019-02-10 stsp fi
157 68ed9ba5 2019-02-10 stsp
158 8d301dd9 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
159 68ed9ba5 2019-02-10 stsp ret="$?"
160 68ed9ba5 2019-02-10 stsp if [ "$ret" != "0" ]; then
161 68ed9ba5 2019-02-10 stsp diff -u $testroot/stdout.expected $testroot/stdout
162 68ed9ba5 2019-02-10 stsp test_done "$testroot" "$ret"
163 68ed9ba5 2019-02-10 stsp return 1
164 68ed9ba5 2019-02-10 stsp fi
165 68ed9ba5 2019-02-10 stsp
166 68ed9ba5 2019-02-10 stsp ls -l $testroot/wt/xfile | grep -q '^-rwx'
167 68ed9ba5 2019-02-10 stsp ret="$?"
168 68ed9ba5 2019-02-10 stsp if [ "$ret" != "0" ]; then
169 68ed9ba5 2019-02-10 stsp echo "file is not executable" >&2
170 68ed9ba5 2019-02-10 stsp ls -l $testroot/wt/xfile >&2
171 68ed9ba5 2019-02-10 stsp fi
172 68ed9ba5 2019-02-10 stsp test_done "$testroot" "$ret"
173 68ed9ba5 2019-02-10 stsp }
174 68ed9ba5 2019-02-10 stsp
175 f6cae3ed 2020-09-13 naddy test_checkout_commit_from_wrong_branch() {
176 45d344f6 2019-05-14 stsp local testroot=`test_init checkout_commit_from_wrong_branch`
177 45d344f6 2019-05-14 stsp
178 45d344f6 2019-05-14 stsp (cd $testroot/repo && git checkout -q -b newbranch)
179 45d344f6 2019-05-14 stsp echo "modified alpha on new branch" > $testroot/repo/alpha
180 45d344f6 2019-05-14 stsp git_commit $testroot/repo -m "modified alpha on new branch"
181 45d344f6 2019-05-14 stsp
182 45d344f6 2019-05-14 stsp local head_rev=`git_show_head $testroot/repo`
183 45d344f6 2019-05-14 stsp got checkout -b master -c $head_rev $testroot/repo $testroot/wt \
184 45d344f6 2019-05-14 stsp > $testroot/stdout 2> $testroot/stderr
185 45d344f6 2019-05-14 stsp ret="$?"
186 45d344f6 2019-05-14 stsp if [ "$ret" == "0" ]; then
187 45d344f6 2019-05-14 stsp test_done "$testroot" "1"
188 45d344f6 2019-05-14 stsp return 1
189 45d344f6 2019-05-14 stsp fi
190 45d344f6 2019-05-14 stsp
191 45d344f6 2019-05-14 stsp echo -n "" > $testroot/stdout.expected
192 45d344f6 2019-05-14 stsp cmp -s $testroot/stdout.expected $testroot/stdout
193 45d344f6 2019-05-14 stsp ret="$?"
194 45d344f6 2019-05-14 stsp if [ "$ret" != "0" ]; then
195 45d344f6 2019-05-14 stsp diff -u $testroot/stdout.expected $testroot/stdout
196 45d344f6 2019-05-14 stsp test_done "$testroot" "$ret"
197 45d344f6 2019-05-14 stsp return 1
198 45d344f6 2019-05-14 stsp fi
199 45d344f6 2019-05-14 stsp
200 4b6c9460 2020-03-05 stsp echo -n "got: target commit is not contained in branch 'master'; " \
201 45d344f6 2019-05-14 stsp > $testroot/stderr.expected
202 4b6c9460 2020-03-05 stsp echo -n "the branch to use must be specified with -b; if necessary " \
203 4b6c9460 2020-03-05 stsp >> $testroot/stderr.expected
204 4b6c9460 2020-03-05 stsp echo -n "a new branch can be created for this commit with "\
205 4b6c9460 2020-03-05 stsp >> $testroot/stderr.expected
206 4b6c9460 2020-03-05 stsp echo "'got branch -c $head_rev BRANCH_NAME'" \
207 4b6c9460 2020-03-05 stsp >> $testroot/stderr.expected
208 45d344f6 2019-05-14 stsp cmp -s $testroot/stderr.expected $testroot/stderr
209 45d344f6 2019-05-14 stsp ret="$?"
210 45d344f6 2019-05-14 stsp if [ "$ret" != "0" ]; then
211 45d344f6 2019-05-14 stsp diff -u $testroot/stderr.expected $testroot/stderr
212 45d344f6 2019-05-14 stsp test_done "$testroot" "$ret"
213 45d344f6 2019-05-14 stsp return 1
214 45d344f6 2019-05-14 stsp fi
215 45d344f6 2019-05-14 stsp
216 45d344f6 2019-05-14 stsp test_done "$testroot" "$ret"
217 45d344f6 2019-05-14 stsp }
218 45d344f6 2019-05-14 stsp
219 f6cae3ed 2020-09-13 naddy test_checkout_tag() {
220 303e2782 2019-08-09 stsp local testroot=`test_init checkout_tag`
221 303e2782 2019-08-09 stsp local tag="1.0.0"
222 303e2782 2019-08-09 stsp
223 303e2782 2019-08-09 stsp (cd $testroot/repo && git tag -a -m "test" $tag)
224 303e2782 2019-08-09 stsp
225 303e2782 2019-08-09 stsp echo "A $testroot/wt/alpha" > $testroot/stdout.expected
226 303e2782 2019-08-09 stsp echo "A $testroot/wt/beta" >> $testroot/stdout.expected
227 303e2782 2019-08-09 stsp echo "A $testroot/wt/epsilon/zeta" >> $testroot/stdout.expected
228 303e2782 2019-08-09 stsp echo "A $testroot/wt/gamma/delta" >> $testroot/stdout.expected
229 303e2782 2019-08-09 stsp echo "Now shut up and hack" >> $testroot/stdout.expected
230 303e2782 2019-08-09 stsp
231 303e2782 2019-08-09 stsp got checkout -c $tag $testroot/repo $testroot/wt > $testroot/stdout
232 303e2782 2019-08-09 stsp ret="$?"
233 303e2782 2019-08-09 stsp if [ "$ret" != "0" ]; then
234 303e2782 2019-08-09 stsp test_done "$testroot" "$ret"
235 303e2782 2019-08-09 stsp return 1
236 303e2782 2019-08-09 stsp fi
237 303e2782 2019-08-09 stsp
238 303e2782 2019-08-09 stsp cmp -s $testroot/stdout.expected $testroot/stdout
239 303e2782 2019-08-09 stsp ret="$?"
240 303e2782 2019-08-09 stsp if [ "$ret" != "0" ]; then
241 303e2782 2019-08-09 stsp diff -u $testroot/stdout.expected $testroot/stdout
242 303e2782 2019-08-09 stsp test_done "$testroot" "$ret"
243 303e2782 2019-08-09 stsp return 1
244 303e2782 2019-08-09 stsp fi
245 303e2782 2019-08-09 stsp
246 303e2782 2019-08-09 stsp echo "alpha" > $testroot/content.expected
247 303e2782 2019-08-09 stsp echo "beta" >> $testroot/content.expected
248 303e2782 2019-08-09 stsp echo "zeta" >> $testroot/content.expected
249 303e2782 2019-08-09 stsp echo "delta" >> $testroot/content.expected
250 303e2782 2019-08-09 stsp cat $testroot/wt/alpha $testroot/wt/beta $testroot/wt/epsilon/zeta \
251 303e2782 2019-08-09 stsp $testroot/wt/gamma/delta > $testroot/content
252 303e2782 2019-08-09 stsp
253 303e2782 2019-08-09 stsp cmp -s $testroot/content.expected $testroot/content
254 303e2782 2019-08-09 stsp ret="$?"
255 303e2782 2019-08-09 stsp if [ "$ret" != "0" ]; then
256 303e2782 2019-08-09 stsp diff -u $testroot/content.expected $testroot/content
257 303e2782 2019-08-09 stsp fi
258 303e2782 2019-08-09 stsp test_done "$testroot" "$ret"
259 303e2782 2019-08-09 stsp }
260 63c5ca5d 2019-08-24 stsp
261 f6cae3ed 2020-09-13 naddy test_checkout_ignores_submodules() {
262 63c5ca5d 2019-08-24 stsp local testroot=`test_init checkout_ignores_submodules`
263 63c5ca5d 2019-08-24 stsp
264 e7303626 2020-05-14 stsp make_single_file_repo $testroot/repo2 foo
265 e7303626 2020-05-14 stsp
266 63c5ca5d 2019-08-24 stsp (cd $testroot/repo && git submodule -q add ../repo2)
267 63c5ca5d 2019-08-24 stsp (cd $testroot/repo && git commit -q -m 'adding submodule')
268 63c5ca5d 2019-08-24 stsp
269 63c5ca5d 2019-08-24 stsp echo "A $testroot/wt/.gitmodules" > $testroot/stdout.expected
270 63c5ca5d 2019-08-24 stsp echo "A $testroot/wt/alpha" >> $testroot/stdout.expected
271 63c5ca5d 2019-08-24 stsp echo "A $testroot/wt/beta" >> $testroot/stdout.expected
272 63c5ca5d 2019-08-24 stsp echo "A $testroot/wt/epsilon/zeta" >> $testroot/stdout.expected
273 63c5ca5d 2019-08-24 stsp echo "A $testroot/wt/gamma/delta" >> $testroot/stdout.expected
274 63c5ca5d 2019-08-24 stsp echo "Now shut up and hack" >> $testroot/stdout.expected
275 303e2782 2019-08-09 stsp
276 63c5ca5d 2019-08-24 stsp got checkout $testroot/repo $testroot/wt > $testroot/stdout
277 63c5ca5d 2019-08-24 stsp ret="$?"
278 63c5ca5d 2019-08-24 stsp if [ "$ret" != "0" ]; then
279 63c5ca5d 2019-08-24 stsp test_done "$testroot" "$ret"
280 63c5ca5d 2019-08-24 stsp return 1
281 63c5ca5d 2019-08-24 stsp fi
282 63c5ca5d 2019-08-24 stsp
283 63c5ca5d 2019-08-24 stsp cmp -s $testroot/stdout.expected $testroot/stdout
284 63c5ca5d 2019-08-24 stsp ret="$?"
285 63c5ca5d 2019-08-24 stsp if [ "$ret" != "0" ]; then
286 63c5ca5d 2019-08-24 stsp diff -u $testroot/stdout.expected $testroot/stdout
287 63c5ca5d 2019-08-24 stsp test_done "$testroot" "$ret"
288 63c5ca5d 2019-08-24 stsp return 1
289 63c5ca5d 2019-08-24 stsp fi
290 63c5ca5d 2019-08-24 stsp
291 63c5ca5d 2019-08-24 stsp echo "alpha" > $testroot/content.expected
292 63c5ca5d 2019-08-24 stsp echo "beta" >> $testroot/content.expected
293 63c5ca5d 2019-08-24 stsp echo "zeta" >> $testroot/content.expected
294 63c5ca5d 2019-08-24 stsp echo "delta" >> $testroot/content.expected
295 63c5ca5d 2019-08-24 stsp cat $testroot/wt/alpha $testroot/wt/beta $testroot/wt/epsilon/zeta \
296 63c5ca5d 2019-08-24 stsp $testroot/wt/gamma/delta > $testroot/content
297 63c5ca5d 2019-08-24 stsp
298 63c5ca5d 2019-08-24 stsp cmp -s $testroot/content.expected $testroot/content
299 63c5ca5d 2019-08-24 stsp ret="$?"
300 63c5ca5d 2019-08-24 stsp if [ "$ret" != "0" ]; then
301 63c5ca5d 2019-08-24 stsp diff -u $testroot/content.expected $testroot/content
302 63c5ca5d 2019-08-24 stsp fi
303 63c5ca5d 2019-08-24 stsp test_done "$testroot" "$ret"
304 63c5ca5d 2019-08-24 stsp }
305 7f47418f 2019-12-20 stsp
306 f6cae3ed 2020-09-13 naddy test_checkout_read_only() {
307 7f47418f 2019-12-20 stsp local testroot=`test_init checkout_read_only`
308 7f47418f 2019-12-20 stsp
309 7f47418f 2019-12-20 stsp # Make the repostiory read-only
310 7f47418f 2019-12-20 stsp chmod -R a-w $testroot/repo
311 7f47418f 2019-12-20 stsp
312 7f47418f 2019-12-20 stsp echo "A $testroot/wt/alpha" > $testroot/stdout.expected
313 7f47418f 2019-12-20 stsp echo "A $testroot/wt/beta" >> $testroot/stdout.expected
314 7f47418f 2019-12-20 stsp echo "A $testroot/wt/epsilon/zeta" >> $testroot/stdout.expected
315 7f47418f 2019-12-20 stsp echo "A $testroot/wt/gamma/delta" >> $testroot/stdout.expected
316 7f47418f 2019-12-20 stsp echo "Now shut up and hack" >> $testroot/stdout.expected
317 7f47418f 2019-12-20 stsp
318 7f47418f 2019-12-20 stsp got checkout $testroot/repo $testroot/wt \
319 7f47418f 2019-12-20 stsp > $testroot/stdout 2> $testroot/stderr
320 7f47418f 2019-12-20 stsp ret="$?"
321 7f47418f 2019-12-20 stsp if [ "$ret" != "0" ]; then
322 7f47418f 2019-12-20 stsp test_done "$testroot" "$ret"
323 7f47418f 2019-12-20 stsp return 1
324 7f47418f 2019-12-20 stsp fi
325 63c5ca5d 2019-08-24 stsp
326 7f47418f 2019-12-20 stsp cmp -s $testroot/stdout.expected $testroot/stdout
327 7f47418f 2019-12-20 stsp ret="$?"
328 7f47418f 2019-12-20 stsp if [ "$ret" != "0" ]; then
329 7f47418f 2019-12-20 stsp diff -u $testroot/stdout.expected $testroot/stdout
330 7f47418f 2019-12-20 stsp test_done "$testroot" "$ret"
331 7f47418f 2019-12-20 stsp return 1
332 7f47418f 2019-12-20 stsp fi
333 7f47418f 2019-12-20 stsp
334 7f47418f 2019-12-20 stsp echo -n "got: warning: could not create a reference " \
335 7f47418f 2019-12-20 stsp > $testroot/stderr.expected
336 7f47418f 2019-12-20 stsp echo -n "to the work tree's base commit; the commit could " \
337 7f47418f 2019-12-20 stsp >> $testroot/stderr.expected
338 7f47418f 2019-12-20 stsp echo -n "be garbage-collected by Git; making the repository " \
339 7f47418f 2019-12-20 stsp >> $testroot/stderr.expected
340 7f47418f 2019-12-20 stsp echo "writable and running 'got update' will prevent this" \
341 7f47418f 2019-12-20 stsp >> $testroot/stderr.expected
342 7f47418f 2019-12-20 stsp cmp -s $testroot/stderr.expected $testroot/stderr
343 7f47418f 2019-12-20 stsp ret="$?"
344 7f47418f 2019-12-20 stsp if [ "$ret" != "0" ]; then
345 7f47418f 2019-12-20 stsp diff -u $testroot/stderr.expected $testroot/stderr
346 7f47418f 2019-12-20 stsp test_done "$testroot" "$ret"
347 7f47418f 2019-12-20 stsp return 1
348 7f47418f 2019-12-20 stsp fi
349 7f47418f 2019-12-20 stsp
350 7f47418f 2019-12-20 stsp echo "alpha" > $testroot/content.expected
351 7f47418f 2019-12-20 stsp echo "beta" >> $testroot/content.expected
352 7f47418f 2019-12-20 stsp echo "zeta" >> $testroot/content.expected
353 7f47418f 2019-12-20 stsp echo "delta" >> $testroot/content.expected
354 7f47418f 2019-12-20 stsp cat $testroot/wt/alpha $testroot/wt/beta $testroot/wt/epsilon/zeta \
355 7f47418f 2019-12-20 stsp $testroot/wt/gamma/delta > $testroot/content
356 7f47418f 2019-12-20 stsp
357 7f47418f 2019-12-20 stsp cmp -s $testroot/content.expected $testroot/content
358 7f47418f 2019-12-20 stsp ret="$?"
359 7f47418f 2019-12-20 stsp if [ "$ret" != "0" ]; then
360 7f47418f 2019-12-20 stsp diff -u $testroot/content.expected $testroot/content
361 7f47418f 2019-12-20 stsp fi
362 7f47418f 2019-12-20 stsp chmod -R u+w $testroot/repo # make repo cleanup work
363 7f47418f 2019-12-20 stsp test_done "$testroot" "$ret"
364 7f47418f 2019-12-20 stsp }
365 bb51a5b4 2020-01-13 stsp
366 f6cae3ed 2020-09-13 naddy test_checkout_into_nonempty_dir() {
367 bb51a5b4 2020-01-13 stsp local testroot=`test_init checkout_into_nonempty_dir`
368 bb51a5b4 2020-01-13 stsp
369 bb51a5b4 2020-01-13 stsp mkdir -p $testroot/wt
370 bb51a5b4 2020-01-13 stsp make_test_tree $testroot/wt
371 bb51a5b4 2020-01-13 stsp
372 bb51a5b4 2020-01-13 stsp got checkout $testroot/repo $testroot/wt > $testroot/stdout \
373 bb51a5b4 2020-01-13 stsp 2> $testroot/stderr
374 bb51a5b4 2020-01-13 stsp ret="$?"
375 bb51a5b4 2020-01-13 stsp if [ "$ret" == "0" ]; then
376 bb51a5b4 2020-01-13 stsp echo "checkout succeeded unexpectedly" >&2
377 bb51a5b4 2020-01-13 stsp test_done "$testroot" "1"
378 bb51a5b4 2020-01-13 stsp return 1
379 bb51a5b4 2020-01-13 stsp fi
380 bb51a5b4 2020-01-13 stsp
381 bb51a5b4 2020-01-13 stsp echo -n > $testroot/stdout.expected
382 bb51a5b4 2020-01-13 stsp cmp -s $testroot/stdout.expected $testroot/stdout
383 bb51a5b4 2020-01-13 stsp ret="$?"
384 bb51a5b4 2020-01-13 stsp if [ "$ret" != "0" ]; then
385 bb51a5b4 2020-01-13 stsp diff -u $testroot/stdout.expected $testroot/stdout
386 bb51a5b4 2020-01-13 stsp test_done "$testroot" "$ret"
387 bb51a5b4 2020-01-13 stsp return 1
388 bb51a5b4 2020-01-13 stsp fi
389 bb51a5b4 2020-01-13 stsp
390 bb51a5b4 2020-01-13 stsp echo "got: $testroot/wt: directory exists and is not empty" \
391 bb51a5b4 2020-01-13 stsp > $testroot/stderr.expected
392 bb51a5b4 2020-01-13 stsp cmp -s $testroot/stderr.expected $testroot/stderr
393 bb51a5b4 2020-01-13 stsp ret="$?"
394 bb51a5b4 2020-01-13 stsp if [ "$ret" != "0" ]; then
395 bb51a5b4 2020-01-13 stsp diff -u $testroot/stderr.expected $testroot/stderr
396 bb51a5b4 2020-01-13 stsp test_done "$testroot" "$ret"
397 bb51a5b4 2020-01-13 stsp return 1
398 bb51a5b4 2020-01-13 stsp fi
399 bb51a5b4 2020-01-13 stsp
400 3b9f0f87 2020-07-23 stsp echo "? $testroot/wt/alpha" > $testroot/stdout.expected
401 3b9f0f87 2020-07-23 stsp echo "? $testroot/wt/beta" >> $testroot/stdout.expected
402 3b9f0f87 2020-07-23 stsp echo "? $testroot/wt/epsilon/zeta" >> $testroot/stdout.expected
403 3b9f0f87 2020-07-23 stsp echo "? $testroot/wt/gamma/delta" >> $testroot/stdout.expected
404 bb51a5b4 2020-01-13 stsp echo "Now shut up and hack" >> $testroot/stdout.expected
405 7f47418f 2019-12-20 stsp
406 bb51a5b4 2020-01-13 stsp got checkout -E $testroot/repo $testroot/wt > $testroot/stdout
407 bb51a5b4 2020-01-13 stsp ret="$?"
408 bb51a5b4 2020-01-13 stsp if [ "$ret" != "0" ]; then
409 bb51a5b4 2020-01-13 stsp test_done "$testroot" "$ret"
410 bb51a5b4 2020-01-13 stsp return 1
411 bb51a5b4 2020-01-13 stsp fi
412 bb51a5b4 2020-01-13 stsp
413 bb51a5b4 2020-01-13 stsp cmp -s $testroot/stdout.expected $testroot/stdout
414 bb51a5b4 2020-01-13 stsp ret="$?"
415 bb51a5b4 2020-01-13 stsp if [ "$ret" != "0" ]; then
416 bb51a5b4 2020-01-13 stsp diff -u $testroot/stdout.expected $testroot/stdout
417 bb51a5b4 2020-01-13 stsp test_done "$testroot" "$ret"
418 bb51a5b4 2020-01-13 stsp return 1
419 bb51a5b4 2020-01-13 stsp fi
420 bb51a5b4 2020-01-13 stsp
421 bb51a5b4 2020-01-13 stsp echo "E $testroot/wt/alpha" > $testroot/stdout.expected
422 bb51a5b4 2020-01-13 stsp echo "E $testroot/wt/beta" >> $testroot/stdout.expected
423 bb51a5b4 2020-01-13 stsp echo "E $testroot/wt/epsilon/zeta" >> $testroot/stdout.expected
424 bb51a5b4 2020-01-13 stsp echo "E $testroot/wt/gamma/delta" >> $testroot/stdout.expected
425 bb51a5b4 2020-01-13 stsp echo "Now shut up and hack" >> $testroot/stdout.expected
426 bb51a5b4 2020-01-13 stsp
427 bb51a5b4 2020-01-13 stsp got checkout -E $testroot/repo $testroot/wt > $testroot/stdout
428 bb51a5b4 2020-01-13 stsp ret="$?"
429 bb51a5b4 2020-01-13 stsp if [ "$ret" != "0" ]; then
430 bb51a5b4 2020-01-13 stsp test_done "$testroot" "$ret"
431 bb51a5b4 2020-01-13 stsp return 1
432 bb51a5b4 2020-01-13 stsp fi
433 bb51a5b4 2020-01-13 stsp
434 bb51a5b4 2020-01-13 stsp cmp -s $testroot/stdout.expected $testroot/stdout
435 bb51a5b4 2020-01-13 stsp ret="$?"
436 bb51a5b4 2020-01-13 stsp if [ "$ret" != "0" ]; then
437 bb51a5b4 2020-01-13 stsp diff -u $testroot/stdout.expected $testroot/stdout
438 bb51a5b4 2020-01-13 stsp test_done "$testroot" "$ret"
439 bb51a5b4 2020-01-13 stsp return 1
440 bb51a5b4 2020-01-13 stsp fi
441 bb51a5b4 2020-01-13 stsp
442 bb51a5b4 2020-01-13 stsp echo "alpha" > $testroot/content.expected
443 bb51a5b4 2020-01-13 stsp echo "beta" >> $testroot/content.expected
444 bb51a5b4 2020-01-13 stsp echo "zeta" >> $testroot/content.expected
445 bb51a5b4 2020-01-13 stsp echo "delta" >> $testroot/content.expected
446 bb51a5b4 2020-01-13 stsp cat $testroot/wt/alpha $testroot/wt/beta $testroot/wt/epsilon/zeta \
447 bb51a5b4 2020-01-13 stsp $testroot/wt/gamma/delta > $testroot/content
448 bb51a5b4 2020-01-13 stsp
449 bb51a5b4 2020-01-13 stsp cmp -s $testroot/content.expected $testroot/content
450 bb51a5b4 2020-01-13 stsp ret="$?"
451 bb51a5b4 2020-01-13 stsp if [ "$ret" != "0" ]; then
452 bb51a5b4 2020-01-13 stsp diff -u $testroot/content.expected $testroot/content
453 bb51a5b4 2020-01-13 stsp test_done "$testroot" "$ret"
454 bb51a5b4 2020-01-13 stsp return 1
455 bb51a5b4 2020-01-13 stsp fi
456 bb51a5b4 2020-01-13 stsp
457 bb51a5b4 2020-01-13 stsp echo "modified alpha" > $testroot/wt/alpha
458 bb51a5b4 2020-01-13 stsp
459 bb51a5b4 2020-01-13 stsp echo "E $testroot/wt/alpha" > $testroot/stdout.expected
460 bb51a5b4 2020-01-13 stsp echo "E $testroot/wt/beta" >> $testroot/stdout.expected
461 bb51a5b4 2020-01-13 stsp echo "E $testroot/wt/epsilon/zeta" >> $testroot/stdout.expected
462 bb51a5b4 2020-01-13 stsp echo "E $testroot/wt/gamma/delta" >> $testroot/stdout.expected
463 bb51a5b4 2020-01-13 stsp echo "Now shut up and hack" >> $testroot/stdout.expected
464 bb51a5b4 2020-01-13 stsp
465 bb51a5b4 2020-01-13 stsp got checkout -E $testroot/repo $testroot/wt > $testroot/stdout
466 bb51a5b4 2020-01-13 stsp ret="$?"
467 bb51a5b4 2020-01-13 stsp if [ "$ret" != "0" ]; then
468 bb51a5b4 2020-01-13 stsp test_done "$testroot" "$ret"
469 bb51a5b4 2020-01-13 stsp return 1
470 bb51a5b4 2020-01-13 stsp fi
471 bb51a5b4 2020-01-13 stsp
472 bb51a5b4 2020-01-13 stsp cmp -s $testroot/stdout.expected $testroot/stdout
473 bb51a5b4 2020-01-13 stsp ret="$?"
474 bb51a5b4 2020-01-13 stsp if [ "$ret" != "0" ]; then
475 bb51a5b4 2020-01-13 stsp diff -u $testroot/stdout.expected $testroot/stdout
476 bb51a5b4 2020-01-13 stsp test_done "$testroot" "$ret"
477 bb51a5b4 2020-01-13 stsp return 1
478 bb51a5b4 2020-01-13 stsp fi
479 bb51a5b4 2020-01-13 stsp
480 bb51a5b4 2020-01-13 stsp echo "modified alpha" > $testroot/content.expected
481 bb51a5b4 2020-01-13 stsp echo "beta" >> $testroot/content.expected
482 bb51a5b4 2020-01-13 stsp echo "zeta" >> $testroot/content.expected
483 bb51a5b4 2020-01-13 stsp echo "delta" >> $testroot/content.expected
484 bb51a5b4 2020-01-13 stsp cat $testroot/wt/alpha $testroot/wt/beta $testroot/wt/epsilon/zeta \
485 bb51a5b4 2020-01-13 stsp $testroot/wt/gamma/delta > $testroot/content
486 bb51a5b4 2020-01-13 stsp
487 bb51a5b4 2020-01-13 stsp cmp -s $testroot/content.expected $testroot/content
488 bb51a5b4 2020-01-13 stsp ret="$?"
489 bb51a5b4 2020-01-13 stsp if [ "$ret" != "0" ]; then
490 bb51a5b4 2020-01-13 stsp diff -u $testroot/content.expected $testroot/content
491 bb51a5b4 2020-01-13 stsp test_done "$testroot" "$ret"
492 4da1bbe9 2020-07-19 stsp return 1
493 bb51a5b4 2020-01-13 stsp fi
494 bb51a5b4 2020-01-13 stsp
495 bb51a5b4 2020-01-13 stsp echo 'M alpha' > $testroot/stdout.expected
496 bb51a5b4 2020-01-13 stsp (cd $testroot/wt && got status > $testroot/stdout)
497 8ba819a3 2020-07-23 stsp
498 8ba819a3 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
499 8ba819a3 2020-07-23 stsp ret="$?"
500 8ba819a3 2020-07-23 stsp if [ "$ret" != "0" ]; then
501 8ba819a3 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
502 8ba819a3 2020-07-23 stsp fi
503 8ba819a3 2020-07-23 stsp test_done "$testroot" "$ret"
504 8ba819a3 2020-07-23 stsp }
505 8ba819a3 2020-07-23 stsp
506 f6cae3ed 2020-09-13 naddy test_checkout_symlink() {
507 8ba819a3 2020-07-23 stsp local testroot=`test_init checkout_symlink`
508 8ba819a3 2020-07-23 stsp
509 8ba819a3 2020-07-23 stsp (cd $testroot/repo && ln -s alpha alpha.link)
510 8ba819a3 2020-07-23 stsp (cd $testroot/repo && ln -s epsilon epsilon.link)
511 8ba819a3 2020-07-23 stsp (cd $testroot/repo && ln -s /etc/passwd passwd.link)
512 b7422a2f 2020-07-23 stsp (cd $testroot/repo && ln -s passwd.link passwd2.link)
513 0ab20ee9 2020-07-23 stsp (cd $testroot/repo && ln -s ../beta epsilon/beta.link)
514 0ab20ee9 2020-07-23 stsp (cd $testroot/repo && ln -s nonexistent nonexistent.link)
515 906c123b 2020-07-23 stsp (cd $testroot/repo && ln -s .got/foo dotgotfoo.link)
516 8ba819a3 2020-07-23 stsp (cd $testroot/repo && git add .)
517 0ab20ee9 2020-07-23 stsp git_commit $testroot/repo -m "add symlinks"
518 8ba819a3 2020-07-23 stsp
519 b7422a2f 2020-07-23 stsp got checkout $testroot/repo $testroot/wt > $testroot/stdout
520 8ba819a3 2020-07-23 stsp ret="$?"
521 8ba819a3 2020-07-23 stsp if [ "$ret" != "0" ]; then
522 b7422a2f 2020-07-23 stsp echo "got checkout failed unexpectedly" >&2
523 8ba819a3 2020-07-23 stsp test_done "$testroot" "$ret"
524 8ba819a3 2020-07-23 stsp return 1
525 8ba819a3 2020-07-23 stsp fi
526 b7422a2f 2020-07-23 stsp
527 b7422a2f 2020-07-23 stsp echo "A $testroot/wt/alpha" > $testroot/stdout.expected
528 b7422a2f 2020-07-23 stsp echo "A $testroot/wt/alpha.link" >> $testroot/stdout.expected
529 b7422a2f 2020-07-23 stsp echo "A $testroot/wt/beta" >> $testroot/stdout.expected
530 b7422a2f 2020-07-23 stsp echo "A $testroot/wt/dotgotfoo.link" >> $testroot/stdout.expected
531 b7422a2f 2020-07-23 stsp echo "A $testroot/wt/epsilon/beta.link" >> $testroot/stdout.expected
532 b7422a2f 2020-07-23 stsp echo "A $testroot/wt/epsilon/zeta" >> $testroot/stdout.expected
533 b7422a2f 2020-07-23 stsp echo "A $testroot/wt/epsilon.link" >> $testroot/stdout.expected
534 b7422a2f 2020-07-23 stsp echo "A $testroot/wt/gamma/delta" >> $testroot/stdout.expected
535 b7422a2f 2020-07-23 stsp echo "A $testroot/wt/nonexistent.link" >> $testroot/stdout.expected
536 b7422a2f 2020-07-23 stsp echo "A $testroot/wt/passwd.link" >> $testroot/stdout.expected
537 b7422a2f 2020-07-23 stsp echo "A $testroot/wt/passwd2.link" >> $testroot/stdout.expected
538 b7422a2f 2020-07-23 stsp echo "Now shut up and hack" >> $testroot/stdout.expected
539 8ba819a3 2020-07-23 stsp
540 b7422a2f 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
541 b7422a2f 2020-07-23 stsp ret="$?"
542 b7422a2f 2020-07-23 stsp if [ "$ret" != "0" ]; then
543 b7422a2f 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
544 b7422a2f 2020-07-23 stsp test_done "$testroot" "$ret"
545 b7422a2f 2020-07-23 stsp return 1
546 b7422a2f 2020-07-23 stsp fi
547 b7422a2f 2020-07-23 stsp
548 8ba819a3 2020-07-23 stsp if ! [ -h $testroot/wt/alpha.link ]; then
549 8ba819a3 2020-07-23 stsp echo "alpha.link is not a symlink"
550 8ba819a3 2020-07-23 stsp test_done "$testroot" "1"
551 8ba819a3 2020-07-23 stsp return 1
552 8ba819a3 2020-07-23 stsp fi
553 8ba819a3 2020-07-23 stsp
554 8ba819a3 2020-07-23 stsp readlink $testroot/wt/alpha.link > $testroot/stdout
555 8ba819a3 2020-07-23 stsp echo "alpha" > $testroot/stdout.expected
556 8ba819a3 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
557 8ba819a3 2020-07-23 stsp ret="$?"
558 8ba819a3 2020-07-23 stsp if [ "$ret" != "0" ]; then
559 8ba819a3 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
560 8ba819a3 2020-07-23 stsp test_done "$testroot" "$ret"
561 8ba819a3 2020-07-23 stsp return 1
562 8ba819a3 2020-07-23 stsp fi
563 bb51a5b4 2020-01-13 stsp
564 8ba819a3 2020-07-23 stsp if ! [ -h $testroot/wt/epsilon.link ]; then
565 8ba819a3 2020-07-23 stsp echo "epsilon.link is not a symlink"
566 8ba819a3 2020-07-23 stsp test_done "$testroot" "1"
567 8ba819a3 2020-07-23 stsp return 1
568 8ba819a3 2020-07-23 stsp fi
569 8ba819a3 2020-07-23 stsp
570 8ba819a3 2020-07-23 stsp readlink $testroot/wt/epsilon.link > $testroot/stdout
571 8ba819a3 2020-07-23 stsp echo "epsilon" > $testroot/stdout.expected
572 bb51a5b4 2020-01-13 stsp cmp -s $testroot/stdout.expected $testroot/stdout
573 bb51a5b4 2020-01-13 stsp ret="$?"
574 bb51a5b4 2020-01-13 stsp if [ "$ret" != "0" ]; then
575 bb51a5b4 2020-01-13 stsp diff -u $testroot/stdout.expected $testroot/stdout
576 8ba819a3 2020-07-23 stsp test_done "$testroot" "$ret"
577 8ba819a3 2020-07-23 stsp return 1
578 bb51a5b4 2020-01-13 stsp fi
579 8ba819a3 2020-07-23 stsp
580 8ba819a3 2020-07-23 stsp if [ -h $testroot/wt/passwd.link ]; then
581 8ba819a3 2020-07-23 stsp echo -n "passwd.link symlink points outside of work tree: " >&2
582 8ba819a3 2020-07-23 stsp readlink $testroot/wt/passwd.link >&2
583 8ba819a3 2020-07-23 stsp test_done "$testroot" "1"
584 8ba819a3 2020-07-23 stsp return 1
585 8ba819a3 2020-07-23 stsp fi
586 8ba819a3 2020-07-23 stsp
587 8ba819a3 2020-07-23 stsp echo -n "/etc/passwd" > $testroot/content.expected
588 8ba819a3 2020-07-23 stsp cp $testroot/wt/passwd.link $testroot/content
589 8ba819a3 2020-07-23 stsp
590 8ba819a3 2020-07-23 stsp cmp -s $testroot/content.expected $testroot/content
591 8ba819a3 2020-07-23 stsp ret="$?"
592 8ba819a3 2020-07-23 stsp if [ "$ret" != "0" ]; then
593 8ba819a3 2020-07-23 stsp diff -u $testroot/content.expected $testroot/content
594 0ab20ee9 2020-07-23 stsp test_done "$testroot" "$ret"
595 0ab20ee9 2020-07-23 stsp return 1
596 0ab20ee9 2020-07-23 stsp fi
597 8ba819a3 2020-07-23 stsp
598 b7422a2f 2020-07-23 stsp if ! [ -h $testroot/wt/passwd2.link ]; then
599 b7422a2f 2020-07-23 stsp echo "passwd2.link is not a symlink"
600 b7422a2f 2020-07-23 stsp test_done "$testroot" "1"
601 b7422a2f 2020-07-23 stsp return 1
602 b7422a2f 2020-07-23 stsp fi
603 b7422a2f 2020-07-23 stsp
604 b7422a2f 2020-07-23 stsp readlink $testroot/wt/passwd2.link > $testroot/stdout
605 b7422a2f 2020-07-23 stsp echo "passwd.link" > $testroot/stdout.expected
606 b7422a2f 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
607 b7422a2f 2020-07-23 stsp ret="$?"
608 b7422a2f 2020-07-23 stsp if [ "$ret" != "0" ]; then
609 b7422a2f 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
610 b7422a2f 2020-07-23 stsp test_done "$testroot" "$ret"
611 b7422a2f 2020-07-23 stsp return 1
612 b7422a2f 2020-07-23 stsp fi
613 b7422a2f 2020-07-23 stsp
614 0ab20ee9 2020-07-23 stsp readlink $testroot/wt/epsilon/beta.link > $testroot/stdout
615 0ab20ee9 2020-07-23 stsp echo "../beta" > $testroot/stdout.expected
616 0ab20ee9 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
617 0ab20ee9 2020-07-23 stsp ret="$?"
618 0ab20ee9 2020-07-23 stsp if [ "$ret" != "0" ]; then
619 0ab20ee9 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
620 0ab20ee9 2020-07-23 stsp test_done "$testroot" "$ret"
621 0ab20ee9 2020-07-23 stsp return 1
622 0ab20ee9 2020-07-23 stsp fi
623 0ab20ee9 2020-07-23 stsp
624 0ab20ee9 2020-07-23 stsp readlink $testroot/wt/nonexistent.link > $testroot/stdout
625 0ab20ee9 2020-07-23 stsp echo "nonexistent" > $testroot/stdout.expected
626 0ab20ee9 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
627 0ab20ee9 2020-07-23 stsp ret="$?"
628 0ab20ee9 2020-07-23 stsp if [ "$ret" != "0" ]; then
629 0ab20ee9 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
630 906c123b 2020-07-23 stsp test_done "$testroot" "$ret"
631 41806587 2020-07-23 stsp return 1
632 906c123b 2020-07-23 stsp fi
633 906c123b 2020-07-23 stsp
634 906c123b 2020-07-23 stsp if [ -h $testroot/wt/dotgotfoo.link ]; then
635 906c123b 2020-07-23 stsp echo -n "dotgotfoo.link symlink points into .got dir: " >&2
636 906c123b 2020-07-23 stsp readlink $testroot/wt/dotgotfoo.link >&2
637 906c123b 2020-07-23 stsp test_done "$testroot" "1"
638 906c123b 2020-07-23 stsp return 1
639 906c123b 2020-07-23 stsp fi
640 906c123b 2020-07-23 stsp
641 906c123b 2020-07-23 stsp echo -n ".got/foo" > $testroot/content.expected
642 906c123b 2020-07-23 stsp cp $testroot/wt/dotgotfoo.link $testroot/content
643 906c123b 2020-07-23 stsp
644 906c123b 2020-07-23 stsp cmp -s $testroot/content.expected $testroot/content
645 906c123b 2020-07-23 stsp ret="$?"
646 906c123b 2020-07-23 stsp if [ "$ret" != "0" ]; then
647 906c123b 2020-07-23 stsp diff -u $testroot/content.expected $testroot/content
648 0ab20ee9 2020-07-23 stsp fi
649 0ab20ee9 2020-07-23 stsp test_done "$testroot" "$ret"
650 bb51a5b4 2020-01-13 stsp }
651 7d61d891 2020-07-23 stsp
652 f6cae3ed 2020-09-13 naddy test_checkout_symlink_relative_wtpath() {
653 7d61d891 2020-07-23 stsp local testroot=`test_init checkout_symlink_with_wtpath`
654 7d61d891 2020-07-23 stsp
655 7d61d891 2020-07-23 stsp (cd $testroot/repo && ln -s alpha alpha.link)
656 7d61d891 2020-07-23 stsp (cd $testroot/repo && ln -s epsilon epsilon.link)
657 7d61d891 2020-07-23 stsp (cd $testroot/repo && ln -s /etc/passwd passwd.link)
658 7d61d891 2020-07-23 stsp (cd $testroot/repo && ln -s ../beta epsilon/beta.link)
659 7d61d891 2020-07-23 stsp (cd $testroot/repo && ln -s nonexistent nonexistent.link)
660 7d61d891 2020-07-23 stsp (cd $testroot/repo && ln -s .got/foo dotgotfoo.link)
661 7d61d891 2020-07-23 stsp (cd $testroot/repo && git add .)
662 7d61d891 2020-07-23 stsp git_commit $testroot/repo -m "add symlinks"
663 7d61d891 2020-07-23 stsp
664 7d61d891 2020-07-23 stsp (cd $testroot && got checkout $testroot/repo wt > /dev/null)
665 7d61d891 2020-07-23 stsp ret="$?"
666 7d61d891 2020-07-23 stsp if [ "$ret" != "0" ]; then
667 7d61d891 2020-07-23 stsp test_done "$testroot" "$ret"
668 7d61d891 2020-07-23 stsp return 1
669 7d61d891 2020-07-23 stsp fi
670 bb51a5b4 2020-01-13 stsp
671 7d61d891 2020-07-23 stsp if ! [ -h $testroot/wt/alpha.link ]; then
672 7d61d891 2020-07-23 stsp echo "alpha.link is not a symlink"
673 7d61d891 2020-07-23 stsp test_done "$testroot" "1"
674 7d61d891 2020-07-23 stsp return 1
675 7d61d891 2020-07-23 stsp fi
676 7d61d891 2020-07-23 stsp
677 7d61d891 2020-07-23 stsp readlink $testroot/wt/alpha.link > $testroot/stdout
678 7d61d891 2020-07-23 stsp echo "alpha" > $testroot/stdout.expected
679 7d61d891 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
680 7d61d891 2020-07-23 stsp ret="$?"
681 7d61d891 2020-07-23 stsp if [ "$ret" != "0" ]; then
682 7d61d891 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
683 7d61d891 2020-07-23 stsp test_done "$testroot" "$ret"
684 7d61d891 2020-07-23 stsp return 1
685 7d61d891 2020-07-23 stsp fi
686 7d61d891 2020-07-23 stsp
687 7d61d891 2020-07-23 stsp if ! [ -h $testroot/wt/epsilon.link ]; then
688 7d61d891 2020-07-23 stsp echo "epsilon.link is not a symlink"
689 7d61d891 2020-07-23 stsp test_done "$testroot" "1"
690 7d61d891 2020-07-23 stsp return 1
691 7d61d891 2020-07-23 stsp fi
692 7d61d891 2020-07-23 stsp
693 7d61d891 2020-07-23 stsp readlink $testroot/wt/epsilon.link > $testroot/stdout
694 7d61d891 2020-07-23 stsp echo "epsilon" > $testroot/stdout.expected
695 7d61d891 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
696 7d61d891 2020-07-23 stsp ret="$?"
697 7d61d891 2020-07-23 stsp if [ "$ret" != "0" ]; then
698 7d61d891 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
699 7d61d891 2020-07-23 stsp test_done "$testroot" "$ret"
700 7d61d891 2020-07-23 stsp return 1
701 7d61d891 2020-07-23 stsp fi
702 7d61d891 2020-07-23 stsp
703 7d61d891 2020-07-23 stsp if [ -h $testroot/wt/passwd.link ]; then
704 7d61d891 2020-07-23 stsp echo -n "passwd.link symlink points outside of work tree: " >&2
705 7d61d891 2020-07-23 stsp readlink $testroot/wt/passwd.link >&2
706 7d61d891 2020-07-23 stsp test_done "$testroot" "1"
707 7d61d891 2020-07-23 stsp return 1
708 7d61d891 2020-07-23 stsp fi
709 7d61d891 2020-07-23 stsp
710 7d61d891 2020-07-23 stsp echo -n "/etc/passwd" > $testroot/content.expected
711 7d61d891 2020-07-23 stsp cp $testroot/wt/passwd.link $testroot/content
712 7d61d891 2020-07-23 stsp
713 7d61d891 2020-07-23 stsp cmp -s $testroot/content.expected $testroot/content
714 7d61d891 2020-07-23 stsp ret="$?"
715 7d61d891 2020-07-23 stsp if [ "$ret" != "0" ]; then
716 7d61d891 2020-07-23 stsp diff -u $testroot/content.expected $testroot/content
717 7d61d891 2020-07-23 stsp test_done "$testroot" "$ret"
718 7d61d891 2020-07-23 stsp return 1
719 7d61d891 2020-07-23 stsp fi
720 7d61d891 2020-07-23 stsp
721 7d61d891 2020-07-23 stsp readlink $testroot/wt/epsilon/beta.link > $testroot/stdout
722 7d61d891 2020-07-23 stsp echo "../beta" > $testroot/stdout.expected
723 7d61d891 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
724 7d61d891 2020-07-23 stsp ret="$?"
725 7d61d891 2020-07-23 stsp if [ "$ret" != "0" ]; then
726 7d61d891 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
727 7d61d891 2020-07-23 stsp test_done "$testroot" "$ret"
728 7d61d891 2020-07-23 stsp return 1
729 7d61d891 2020-07-23 stsp fi
730 7d61d891 2020-07-23 stsp
731 7d61d891 2020-07-23 stsp readlink $testroot/wt/nonexistent.link > $testroot/stdout
732 7d61d891 2020-07-23 stsp echo "nonexistent" > $testroot/stdout.expected
733 7d61d891 2020-07-23 stsp cmp -s $testroot/stdout.expected $testroot/stdout
734 7d61d891 2020-07-23 stsp ret="$?"
735 7d61d891 2020-07-23 stsp if [ "$ret" != "0" ]; then
736 7d61d891 2020-07-23 stsp diff -u $testroot/stdout.expected $testroot/stdout
737 7d61d891 2020-07-23 stsp test_done "$testroot" "$ret"
738 41806587 2020-07-23 stsp return 1
739 7d61d891 2020-07-23 stsp fi
740 7d61d891 2020-07-23 stsp
741 7d61d891 2020-07-23 stsp if [ -h $testroot/wt/dotgotfoo.link ]; then
742 7d61d891 2020-07-23 stsp echo -n "dotgotfoo.link symlink points into .got dir: " >&2
743 7d61d891 2020-07-23 stsp readlink $testroot/wt/dotgotfoo.link >&2
744 7d61d891 2020-07-23 stsp test_done "$testroot" "1"
745 7d61d891 2020-07-23 stsp return 1
746 7d61d891 2020-07-23 stsp fi
747 7d61d891 2020-07-23 stsp
748 7d61d891 2020-07-23 stsp echo -n ".got/foo" > $testroot/content.expected
749 7d61d891 2020-07-23 stsp cp $testroot/wt/dotgotfoo.link $testroot/content
750 7d61d891 2020-07-23 stsp
751 7d61d891 2020-07-23 stsp cmp -s $testroot/content.expected $testroot/content
752 7d61d891 2020-07-23 stsp ret="$?"
753 7d61d891 2020-07-23 stsp if [ "$ret" != "0" ]; then
754 7d61d891 2020-07-23 stsp diff -u $testroot/content.expected $testroot/content
755 7d61d891 2020-07-23 stsp fi
756 7d61d891 2020-07-23 stsp test_done "$testroot" "$ret"
757 7d61d891 2020-07-23 stsp }
758 20b7abb3 2020-10-22 stsp
759 20b7abb3 2020-10-22 stsp test_checkout_repo_with_unknown_extension() {
760 20b7abb3 2020-10-22 stsp local testroot=`test_init checkout_repo_with_unknown_extension`
761 20b7abb3 2020-10-22 stsp
762 20b7abb3 2020-10-22 stsp (cd $testroot/repo &&
763 20b7abb3 2020-10-22 stsp git config --add extensions.badExtension true)
764 20b7abb3 2020-10-22 stsp (cd $testroot/repo &&
765 20b7abb3 2020-10-22 stsp git config --add extensions.otherBadExtension 0)
766 7d61d891 2020-07-23 stsp
767 20b7abb3 2020-10-22 stsp echo "got: badExtension: unsupported repository format extension" \
768 20b7abb3 2020-10-22 stsp > $testroot/stderr.expected
769 20b7abb3 2020-10-22 stsp got checkout $testroot/repo $testroot/wt \
770 20b7abb3 2020-10-22 stsp > $testroot/stdout 2> $testroot/stderr
771 20b7abb3 2020-10-22 stsp
772 20b7abb3 2020-10-22 stsp ret="$?"
773 20b7abb3 2020-10-22 stsp if [ "$ret" == "0" ]; then
774 20b7abb3 2020-10-22 stsp echo "got checkout command succeeded unexpectedly" >&2
775 20b7abb3 2020-10-22 stsp test_done "$testroot" "1"
776 20b7abb3 2020-10-22 stsp return 1
777 20b7abb3 2020-10-22 stsp fi
778 20b7abb3 2020-10-22 stsp
779 20b7abb3 2020-10-22 stsp cmp -s $testroot/stderr.expected $testroot/stderr
780 20b7abb3 2020-10-22 stsp ret="$?"
781 20b7abb3 2020-10-22 stsp if [ "$ret" != "0" ]; then
782 20b7abb3 2020-10-22 stsp diff -u $testroot/stderr.expected $testroot/stderr
783 20b7abb3 2020-10-22 stsp fi
784 20b7abb3 2020-10-22 stsp test_done "$testroot" "$ret"
785 20b7abb3 2020-10-22 stsp }
786 20b7abb3 2020-10-22 stsp
787 7fb414ae 2020-08-08 stsp test_parseargs "$@"
788 0e673013 2019-01-02 stsp run_test test_checkout_basic
789 80c1b583 2019-08-07 stsp run_test test_checkout_dir_exists
790 80c1b583 2019-08-07 stsp run_test test_checkout_dir_not_empty
791 68ed9ba5 2019-02-10 stsp run_test test_checkout_sets_xbit
792 45d344f6 2019-05-14 stsp run_test test_checkout_commit_from_wrong_branch
793 303e2782 2019-08-09 stsp run_test test_checkout_tag
794 63c5ca5d 2019-08-24 stsp run_test test_checkout_ignores_submodules
795 7f47418f 2019-12-20 stsp run_test test_checkout_read_only
796 bb51a5b4 2020-01-13 stsp run_test test_checkout_into_nonempty_dir
797 8ba819a3 2020-07-23 stsp run_test test_checkout_symlink
798 7d61d891 2020-07-23 stsp run_test test_checkout_symlink_relative_wtpath
799 20b7abb3 2020-10-22 stsp run_test test_checkout_repo_with_unknown_extension